using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DesignAll
{
	/// <summary>
	/// LayerFrm ժҪ˵
	/// </summary>
	public class LayerForm : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components;

		public LayerForm()
		{
			//
			// Windows ֧
			//
			InitializeComponent();

			//
			// TODO:  InitializeComponent úκι캯
			//
		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(LayerForm));
			this.treeView1 = new System.Windows.Forms.TreeView();
			this.imageList1 = new System.Windows.Forms.ImageList(this.components);
			this.btnNew = new System.Windows.Forms.Button();
			this.btnDelete = new System.Windows.Forms.Button();
			this.btnShowHide = new System.Windows.Forms.Button();
			this.btnRefresh = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// treeView1
			// 
			this.treeView1.Dock = System.Windows.Forms.DockStyle.Bottom;
			this.treeView1.ImageList = this.imageList1;
			this.treeView1.Indent = 19;
			this.treeView1.LabelEdit = true;
			this.treeView1.Location = new System.Drawing.Point(0, 42);
			this.treeView1.Name = "treeView1";
			this.treeView1.Size = new System.Drawing.Size(282, 136);
			this.treeView1.TabIndex = 0;
			this.treeView1.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.treeView1_AfterSelect);
			this.treeView1.AfterLabelEdit += new System.Windows.Forms.NodeLabelEditEventHandler(this.treeView1_AfterLabelEdit);
			// 
			// imageList1
			// 
			this.imageList1.ImageSize = new System.Drawing.Size(16, 16);
			this.imageList1.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imageList1.ImageStream")));
			this.imageList1.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// btnNew
			// 
			this.btnNew.Location = new System.Drawing.Point(8, 8);
			this.btnNew.Name = "btnNew";
			this.btnNew.Size = new System.Drawing.Size(40, 24);
			this.btnNew.TabIndex = 1;
			this.btnNew.Text = "&New";
			this.btnNew.Click += new System.EventHandler(this.btnNew_Click);
			// 
			// btnDelete
			// 
			this.btnDelete.Location = new System.Drawing.Point(56, 8);
			this.btnDelete.Name = "btnDelete";
			this.btnDelete.Size = new System.Drawing.Size(56, 24);
			this.btnDelete.TabIndex = 2;
			this.btnDelete.Text = "&Delete";
			this.btnDelete.Click += new System.EventHandler(this.btnDelete_Click);
			// 
			// btnShowHide
			// 
			this.btnShowHide.Location = new System.Drawing.Point(120, 8);
			this.btnShowHide.Name = "btnShowHide";
			this.btnShowHide.Size = new System.Drawing.Size(80, 24);
			this.btnShowHide.TabIndex = 3;
			this.btnShowHide.Text = "Show/Hide";
			this.btnShowHide.Click += new System.EventHandler(this.btnShowHide_Click);
			// 
			// btnRefresh
			// 
			this.btnRefresh.Location = new System.Drawing.Point(208, 8);
			this.btnRefresh.Name = "btnRefresh";
			this.btnRefresh.Size = new System.Drawing.Size(64, 24);
			this.btnRefresh.TabIndex = 4;
			this.btnRefresh.Text = "&Refresh";
			this.btnRefresh.Click += new System.EventHandler(this.btnRefresh_Click);
			// 
			// LayerForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(282, 178);
			this.Controls.Add(this.btnRefresh);
			this.Controls.Add(this.btnShowHide);
			this.Controls.Add(this.btnDelete);
			this.Controls.Add(this.btnNew);
			this.Controls.Add(this.treeView1);
			this.Font = new System.Drawing.Font("Arial", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedToolWindow;
			this.MaximizeBox = false;
			this.Name = "LayerForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
			this.Text = "Layer";
			this.TopMost = true;
			this.Load += new System.EventHandler(this.LayerForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private System.Windows.Forms.TreeView treeView1;
		private System.Windows.Forms.ImageList imageList1;
		private System.Windows.Forms.Button btnNew;
		private System.Windows.Forms.Button btnDelete;
		private System.Windows.Forms.Button btnShowHide;
		private System.Windows.Forms.Button btnRefresh;

		public MainForm mainForm;

		private void RefreshIt()
		{
			Int32 i;
			Int32 id;
			TreeNode treeNode;

			treeView1.Nodes.Clear();

			for (i=0;i<mainForm.myCAD1.GetLayersCount();++i)
			{
				id = mainForm.myCAD1.GetLayerIdByNo(i);
				if (id > -1)
				{
					treeNode = treeView1.Nodes.Add(mainForm.myCAD1.GetLayerNameById(id));

					if (mainForm.myCAD1.IsVisibleLayerByID(id)==true)
					{
						treeNode.ImageIndex = 0;
						treeNode.SelectedImageIndex = 0;
					}
					else
					{
						treeNode.ImageIndex = 1;
						treeNode.SelectedImageIndex = 1;
					}

					if (mainForm.myCAD1.CurrentLayerId == id)
						treeView1.SelectedNode = treeNode;


				}
			}
			
			
		}

		private void LayerForm_Load(object sender, System.EventArgs e)
		{
			RefreshIt();
		}

		private void btnNew_Click(object sender, System.EventArgs e)
		{
			mainForm.myCAD1.NewLayer("Layer" + Convert.ToString(mainForm.myCAD1.GetMaxLayerId()+1),true);
			RefreshIt();
			treeView1.Focus();
		}

		private void btnDelete_Click(object sender, System.EventArgs e)
		{
			Int32 id;
			if (treeView1.SelectedNode.Index > -1)
			{
				id = mainForm.myCAD1.GetLayerIdByNo(treeView1.SelectedNode.Index);
				mainForm.myCAD1.DeleteLayerById(id);
				RefreshIt();
			}
			treeView1.Focus();
		}

		private void btnShowHide_Click(object sender, System.EventArgs e)
		{
			Int32 id;

			id = mainForm.myCAD1.GetLayerIdByNo(treeView1.SelectedNode.Index);
			if (id > -1)
			{
				if (mainForm.myCAD1.IsVisibleLayerByID(id) == true)
				{
					/*
					if (mainForm.myCAD1.CurrentLayerId == id)
					{
						MessageBox.Show("Don not change current layer visible state!","DesignAll",MessageBoxButtons.OK,MessageBoxIcon.Warning);
						return;
					}
					*/			
					mainForm.myCAD1.InVisibleLayerById(id);
				}
				else
				{
					mainForm.myCAD1.VisibleLayerById(id);
				}
				RefreshIt();
			}
			treeView1.Focus();
		}

		private void btnRefresh_Click(object sender, System.EventArgs e)
		{
			RefreshIt();
			treeView1.Focus();
		}

		private void treeView1_AfterLabelEdit(object sender, System.Windows.Forms.NodeLabelEditEventArgs e)
		{
			if (e.Label !=null)
				mainForm.myCAD1.SetLayerNameByName(e.Node.Text,e.Label);
		}

		private void treeView1_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			mainForm.myCAD1.CurrentLayerId = mainForm.myCAD1.GetLayerIdByNo(e.Node.Index);
		}

	}
}
